commit 6f6fc9bb9b21df5c7bf1ebf378550732b998c4b9
Author: freddy77 <freddy77>
Date:   Wed Jun 10 16:44:56 2009 +0000

    limit indentation

diff --git a/ChangeLog b/ChangeLog
index 36817f4..8d7cea0 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Wed Jun 10 18:44:48 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/ctlib/ct.c: limit indentation
+
 Tue Jun  9 10:54:29 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/apps/datacopy.c src/ctlib/blk.c src/ctlib/cs.c:
 	* src/ctlib/ct.c src/odbc/connectparams.c src/odbc/descriptor.c:
@@ -1635,4 +1638,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2810 2009/06/09 08:55:23 freddy77 Exp $
+$Id: ChangeLog,v 1.2811 2009/06/10 16:44:56 freddy77 Exp $
diff --git a/src/ctlib/ct.c b/src/ctlib/ct.c
index b74c663..b3b331a 100644
--- a/src/ctlib/ct.c
+++ b/src/ctlib/ct.c
@@ -39,7 +39,7 @@
 #include "tdsstring.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: ct.c,v 1.194 2009/06/09 08:55:23 freddy77 Exp $");
+TDS_RCSID(var, "$Id: ct.c,v 1.195 2009/06/10 16:44:56 freddy77 Exp $");
 
 
 static char * ct_describe_cmd_state(CS_INT state);
@@ -4157,48 +4157,42 @@ _ct_fill_param(CS_INT cmd_type, CS_PARAM *param, CS_DATAFMT *datafmt, CS_VOID *d
 		param->ind = &param->indicator_value;
 		*(param->ind) = *indicator;
 
-		/* here's one way of passing a null parameter */
-
-		if (*indicator == -1) {
+		/*
+		 * There are two ways to indicate a parameter with a null value:
+		 * - Pass indicator as -1. In this case, data and datalen are ignored.
+		 * - Pass data as NULL and datalen as 0 or CS_UNUSED
+		 */
+		if (*indicator == -1 || (data == NULL && (*datalen == 0 || *datalen == CS_UNUSED))) {
 			param->value = NULL;
 			*(param->datalen) = 0;
 			param_is_null = 1;
 		} else {
+			/* datafmt.datalen is ignored for fixed length types */
 
-			/* and here's another... */
-			if ((*datalen == 0 || *datalen == CS_UNUSED) && data == NULL) {
-				param->value = NULL;
-				*(param->datalen) = 0;
-				param_is_null = 1;
+			if (is_fixed_type(param->type)) {
+				*(param->datalen) = tds_get_size_by_type(param->type);
 			} else {
+				*(param->datalen) = (*datalen == CS_UNUSED) ? 0 : *datalen;
+			}
 
-				/* datafmt.datalen is ignored for fixed length types */
-
-				if (is_fixed_type(param->type)) {
-					*(param->datalen) = tds_get_size_by_type(param->type);
-				} else {
-					*(param->datalen) = (*datalen == CS_UNUSED) ? 0 : *datalen;
-				}
-
-				if (*(param->datalen) && data) {
-					if (*(param->datalen) == CS_NULLTERM) {
-						tdsdump_log(TDS_DBG_INFO1, 
-							    " _ct_fill_param() about to strdup string %u bytes long\n",
-							    (unsigned int) strlen(data));
-						*(param->datalen) = strlen(data);
-					} else if (*(param->datalen) < 0) {
-						return CS_FAIL;
-					}
-					param->value = malloc(*(param->datalen));
-					if (param->value == NULL)
-						return CS_FAIL;
-					memcpy(param->value, data, *(param->datalen));
-					param->param_by_value = 1;
-				} else {
-					param->value = NULL;
-					*(param->datalen) = 0;
-					param_is_null = 1;
+			if (*(param->datalen) && data) {
+				if (*(param->datalen) == CS_NULLTERM) {
+					tdsdump_log(TDS_DBG_INFO1,
+						    " _ct_fill_param() about to strdup string %u bytes long\n",
+						    (unsigned int) strlen(data));
+					*(param->datalen) = strlen(data);
+				} else if (*(param->datalen) < 0) {
+					return CS_FAIL;
 				}
+				param->value = malloc(*(param->datalen));
+				if (param->value == NULL)
+					return CS_FAIL;
+				memcpy(param->value, data, *(param->datalen));
+				param->param_by_value = 1;
+			} else {
+				param->value = NULL;
+				*(param->datalen) = 0;
+				param_is_null = 1;
 			}
 		}
 

